; Exercici: crear noves regles i instancies que les cumpleixin
; -> carregar al clips, al men execution escullim step si volem aplicar 1 regla
; o run si volem aplicar totes les posibles fins al final. A la finestar Agenda
; es visualitzen les regles aplicables i a Instances els objectes.
; Utilidad interesante: Defrule Manager

(clear)
(load "regles.clp")

(make-instance MobyDick of BalenesBlaves)
(make-instance BigMobyDick of BalenesBlaves (pes 4500))
(make-instance VeryBigMobyDick of BalenesBlaves (pes 7000))
(make-instance Bally of BalenesArtiques)
(make-instance BigBally of BalenesArtiques (pes 8000) (color blau))
(make-instance Dufi of Dofins (color negre))
(make-instance Dufi2 of Dofins (color blau))
(make-instance BigMobyDickMax of Balenes (pes 10000))

; Imprimir per pantalla la informaci dels dofins negres
(defrule mostrar-negre
    ?obj <- (object (is-a Dofins) (color negre))
    =>
    (printout T "He trobat un animal negre, amb aquestes dades:" crlf)
    (send ?obj print)   
)

; Esborrar totes les balenes que no siguin de color blau i pesin ms de 7500
(defrule eliminar-balenes 
    ?obj <- (object (is-a Balenes) (color ~blau) (pes ?p &:(> ?p 7500)))
    =>
    (printout T "He trobat una balena de pes superior
     a 7500 que no es blava." crlf)
    (send ?obj delete)
    (printout T "Esborrada!")
)

; Imprimir les dades de les BalenesBlaves que tinguin un pes entre 3000 i 5000
(defrule rang-de-pes 
    ?obj <- (object (is-a BalenesBlaves) (pes ?p &:(> ?p 3000) &:(< ?p 5000)))
    =>
    (printout T "He trobat una balena de pes superior
     a 3000 i inferior a 5000." crlf)
    (send ?obj print)
)

; Posar de color verd totes les Balenesrtiques
(defrule pas-a-verd
    ?obj <- (object (is-a BalenesArtiques) (color ~verd))
    =>
    (printout T (instance-name ?obj) " s un animal aquatic no verd." crlf)
    (send ?obj put-color verd)
    (printout T "Ara ja es verd." crlf)
    (send ?obj print)
)

; Sumar 200 quilos al pes de tots els dofins
(defrule sumar-pes
    ?obj <- (object (is-a Dofins) (pes ?p))
    =>
    (printout T "Sumen 200 al pes del dofi:" crlf)
    (send ?obj print)
    (send ?obj put-pes (+ ?p 200))
    (send ?obj print)
)

