;;; Cal posar (pattern-match reactive) a una classe per a que
;;; puguem escriure regles on es demanin condicions
;;; sobre objectes d'aquesta classe.
;;; Les classes reactives han de ser concretes, no
;;; poden ser abstractes.

(defclass Animals
   (is-a USER)
   (role concrete)
   (pattern-match reactive)
   (slot pes (create-accessor write) (type INTEGER))
   (slot color (create-accessor write) (type SYMBOL))
   (slot vola?)
   (slot neda?)
)

(defclass AnimalsAquatics
   (is-a Animals)
   (role concrete)
   (slot vola? (storage shared)  (access read-only)  (default no))
   (slot neda? (storage shared) (access read-only) (default si))
)

(defclass Dofins
   (is-a AnimalsAquatics)
   (role concrete)
   (slot pes (source composite) (default 2000))
)

(defclass  Balenes
   (is-a AnimalsAquatics)
   (role concrete)
   (slot pes  (source composite) (default 3000))
)

(defclass BalenesBlaves
   (is-a Balenes)
   (role concrete)
   (slot color (source composite) (default blau))
)

(defclass BalenesArtiques
   (is-a Balenes)
   (role concrete)
   (slot pes (source composite) (default 4500))
)
 